Subject: Re: [PATCH] filter: introduce SKF_AD_VLAN_PROTO BPF extension

From: Daniel Borkmann <[email-masked]>
Date: Fri, 06 Mar 2015 18:54:25 +0100

On 03/06/2015 03:02 PM, Michal Kubecek wrote:
> On Thu, Mar 05, 2015 at 09:03:12PM +0100, Daniel Borkmann wrote:
>> On 03/05/2015 05:52 PM, Alexei Starovoitov wrote:
>>
>>> At this point I think it's up to Dave to decide whether we need
>>> this patch (after fixing the issue pointed by Denis) or not.
>>> imo there is a benefit of giving programs more visibility into
>>> skb metadata.
>>
>> I'm not really a big fan of it, but given we added commit a0cdfcf39362
>> ("packet: deliver VLAN TPID to userspace") to packet sockets ...
>
> IMHO the motivation here was not to allow filtering by TPID but because
> without it, libpcap and its users had no chance to get this information
> for packets captured on devices with Rx VLAN offloading so that e.g.
> "tcpdump -e" was showing (guessed) TPID of 0x8100 for all of them, no
> matter what the actual TPID was.

I believe you are referring to VLAN_TPID() in libpcap : So on newer
kernels that indicate TP_STATUS_VLAN_TPID_VALID, it should provide
you the correct TPID via packet socket when offloaded, otherwise it
only hard-codes ETH_P_8021Q in any case.